Subject: Re: [PATCH 1/1] Big endian swap for Marvell 6440 SAS driver

From: Cédric Cano <[email-masked]>
Date: Tue, 14 Jun 2011 08:42:59 +0200

Hi Ben,

You're alright! I hadn't thought to use le32_to_cpu.
Do you want I make a new patch?

Cedric

Le 12/06/2011 00:45, Benjamin Herrenschmidt a écrit :
> On Fri, 2011-06-10 at 15:56 +0200, Cédric Cano wrote:
>> Hi,
>>
>> Marvell SAS driver doesn't work on powerpc architecture due to big
>> endian swap. I've tested it with the MV6440 chip.
>> Here you can find the patch for Linux 2.6.39.1.
>>
>> Cedric Cano
>>
>> Signed-off-by: Cedric Cano<[email-masked]>
>> ---
>> --- drivers/scsi/mvsas/mv_sas.c    2011-06-10 15:50:04.000000000 +0200
>> +++ drivers/scsi/mvsas/mv_sas.c    2011-06-10 15:50:12.000000000 +0200
>> @@ -1143,6 +1143,14 @@
>>        MVS_CHIP_DISP->write_port_cfg_addr(mvi, i, PHYR_SATA_SIG0);
>>        s[0] = MVS_CHIP_DISP->read_port_cfg_data(mvi, i);
>>
>> +    /* swap for big endian devices because of use of these data in bytes */
>> +#ifdef __BIG_ENDIAN
>> +    s[0] = swab32(s[0]);
>> +    s[1] = swab32(s[1]);
>> +    s[2] = swab32(s[2]);
>> +    s[3] = swab32(s[3]);
>> +#endif /* __BIG_ENDIAN */
> Hi Cedric !
>
> Thanks for this. CC'ing linux-scsi.
>
> Note that it would probably have been better to use le32_to_cpu, which
> avoids the ifdef completely.
>
> Cheers,
> Ben.
>
>>        /* Workaround: take some ATAPI devices for ATA */
>>        if (((s[1]&  0x00FFFFFF) == 0x00EB1401)&&  (*(u8 *)&s[3] == 0x01))
>>            s[1] = 0x00EB1401 | (*((u8 *)&s[1] + 3)&  0x10);
>>
>> ---
>> _______________________________________________
>> Linuxppc-dev mailing list
>> [email-masked]
>> https://lists.ozlabs.org/listinfo/linuxppc-dev
>
>